// home page - https://www.mql5.com/ru/users/vict
#ifndef VIM_MQH
#define VIM_MQH

#ifdef VIM
//--------------------------------------------------------------------
typedef unsigned uint;
typedef unsigned long long datetime;
typedef unsigned short ushort;
typedef unsigned char uchar;
typedef unsigned long ulong;
typedef unsigned color;
#define NULL 0

struct string
{
    string();
    string(const char*);
};
string operator+(const char*, const string &);
string operator+(const string &, const char*);
string operator+(const string &, const string &);
string &operator+=(const string &, const string &);
string &operator+=(const string &, const char*);

enum ENUM_FILE_POSITION   
{
    SEEK_CUR,
    SEEK_END,
    SEEK_SET
};
constexpr int FILE_ANSI = 0;
constexpr int FILE_BIN = 0;
constexpr int FILE_COMMON = 0;
constexpr int FILE_CREATE_DATE = 0;
constexpr int FILE_CSV = 0;
constexpr int FILE_END = 0;
constexpr int FILE_EXISTS = 0;
constexpr int FILE_READ = 0;
constexpr int FILE_REWRITE = 0;
constexpr int FILE_SHARE_READ = 0;
constexpr int FILE_SHARE_WRITE = 0;
constexpr int FILE_SIZE = 0;
constexpr int FILE_TXT = 0;
constexpr int FILE_UNICODE = 0;
constexpr int FILE_WRITE = 0;
constexpr int OBJ_ARROW = 0;
constexpr int OBJ_ARROW_BUY = 0;
constexpr int OBJ_ARROW_CHECK = 0;
constexpr int OBJ_ARROW_DOWN = 0;
constexpr int OBJ_ARROW_LEFT_PRICE = 0;
constexpr int OBJ_ARROW_RIGHT_PRICE = 0;
constexpr int OBJ_ARROW_SELL = 0;
constexpr int OBJ_ARROW_STOP = 0;
constexpr int OBJ_ARROW_THUMB_DOWN = 0;
constexpr int OBJ_ARROW_THUMB_UP = 0;
constexpr int OBJ_ARROW_UP = 0;
constexpr int OBJ_ARROWED_LINE = 0;
constexpr int OBJ_BITMAP = 0;
constexpr int OBJ_BITMAP_LABEL = 0;
constexpr int OBJ_BUTTON = 0;
constexpr int OBJ_CHANNEL = 0;
constexpr int OBJ_CHART = 0;
constexpr int OBJ_CYCLES = 0;
constexpr int OBJ_EDIT = 0;
constexpr int OBJ_ELLIOTWAVE3 = 0;
constexpr int OBJ_ELLIOTWAVE5 = 0;
constexpr int OBJ_ELLIPSE = 0;
constexpr int OBJ_EVENT = 0;
constexpr int OBJ_EXPANSION = 0;
constexpr int OBJ_FIBO = 0;
constexpr int OBJ_FIBOARC = 0;
constexpr int OBJ_FIBOCHANNEL = 0;
constexpr int OBJ_FIBOFAN = 0;
constexpr int OBJ_FIBOTIMES = 0;
constexpr int OBJ_GANNFAN = 0;
constexpr int OBJ_GANNGRID = 0;
constexpr int OBJ_GANNLINE = 0;
constexpr int OBJ_HLINE = 0;
constexpr int OBJ_LABEL = 0;
constexpr int OBJ_PITCHFORK = 0;
constexpr int OBJ_RECTANGLE = 0;
constexpr int OBJ_RECTANGLE_LABEL = 0;
constexpr int OBJ_REGRESSION = 0;
constexpr int OBJ_STDDEVCHANNEL = 0;
constexpr int OBJ_TEXT = 0;
constexpr int OBJ_TREND = 0;
constexpr int OBJ_TRENDBYANGLE = 0;
constexpr int OBJ_TRIANGLE = 0;
constexpr int OBJ_VLINE = 0;
constexpr int OBJPROP_ALIGN = 0;
constexpr int OBJPROP_ANCHOR = 0;
constexpr int OBJPROP_ANGLE = 0;
constexpr int OBJPROP_ARROWCODE = 0;
constexpr int OBJPROP_BACK = 0;
constexpr int OBJPROP_BGCOLOR = 0;
constexpr int OBJPROP_BMPFILE = 0;
constexpr int OBJPROP_BORDER_COLOR = 0;
constexpr int OBJPROP_BORDER_TYPE = 0;
constexpr int OBJPROP_CHART_ID = 0;
constexpr int OBJPROP_CHART_SCALE = 0;
constexpr int OBJPROP_COLOR = 0;
constexpr int OBJPROP_CORNER = 0;
constexpr int OBJPROP_CREATETIME = 0;
constexpr int OBJPROP_DATE_SCALE = 0;
constexpr int OBJPROP_DEGREE = 0;
constexpr int OBJPROP_DEVIATION = 0;
constexpr int OBJPROP_DIRECTION = 0;
constexpr int OBJPROP_DRAWLINES = 0;
constexpr int OBJPROP_ELLIPSE = 0;
constexpr int OBJPROP_FILL = 0;
constexpr int OBJPROP_FONT = 0;
constexpr int OBJPROP_FONTSIZE = 0;
constexpr int OBJPROP_HIDDEN = 0;
constexpr int OBJPROP_LEVELCOLOR = 0;
constexpr int OBJPROP_LEVELS = 0;
constexpr int OBJPROP_LEVELSTYLE = 0;
constexpr int OBJPROP_LEVELTEXT = 0;
constexpr int OBJPROP_LEVELVALUE = 0;
constexpr int OBJPROP_LEVELWIDTH = 0;
constexpr int OBJPROP_NAME = 0;
constexpr int OBJPROP_PERIOD = 0;
constexpr int OBJPROP_PRICE = 0;
constexpr int OBJPROP_PRICE_SCALE = 0;
constexpr int OBJPROP_RAY = 0;
constexpr int OBJPROP_RAY_LEFT = 0;
constexpr int OBJPROP_RAY_RIGHT = 0;
constexpr int OBJPROP_READONLY = 0;
constexpr int OBJPROP_SCALE = 0;
constexpr int OBJPROP_SELECTABLE = 0;
constexpr int OBJPROP_SELECTED = 0;
constexpr int OBJPROP_STATE = 0;
constexpr int OBJPROP_STYLE = 0;
constexpr int OBJPROP_SYMBOL = 0;
constexpr int OBJPROP_TEXT = 0;
constexpr int OBJPROP_TIME = 0;
constexpr int OBJPROP_TIMEFRAMES = 0;
constexpr int OBJPROP_TOOLTIP = 0;
constexpr int OBJPROP_TYPE = 0;
constexpr int OBJPROP_WIDTH = 0;
constexpr int OBJPROP_XDISTANCE = 0;
constexpr int OBJPROP_XOFFSET = 0;
constexpr int OBJPROP_XSIZE = 0;
constexpr int OBJPROP_YDISTANCE = 0;
constexpr int OBJPROP_YOFFSET = 0;
constexpr int OBJPROP_YSIZE = 0;
constexpr int OBJPROP_ZORDER = 0;
constexpr int ORDER_COMMENT = 0;
constexpr int ORDER_FILLING_FOK = 0;
constexpr int ORDER_FILLING_IOC = 0;
constexpr int ORDER_FILLING_RETURN = 0;
constexpr int ORDER_MAGIC = 0;
constexpr int ORDER_POSITION_ID = 0;
constexpr int ORDER_PRICE_CURRENT = 0;
constexpr int ORDER_PRICE_OPEN = 0;
constexpr int ORDER_PRICE_STOPLIMIT = 0;
constexpr int ORDER_SL = 0;
constexpr int ORDER_STATE = 0;
constexpr int ORDER_STATE_CANCELED = 0;
constexpr int ORDER_STATE_EXPIRED = 0;
constexpr int ORDER_STATE_FILLED = 0;
constexpr int ORDER_STATE_PARTIAL = 0;
constexpr int ORDER_STATE_PLACED = 0;
constexpr int ORDER_STATE_REJECTED = 0;
constexpr int ORDER_STATE_REQUEST_ADD = 0;
constexpr int ORDER_STATE_REQUEST_CANCEL = 0;
constexpr int ORDER_STATE_REQUEST_MODIFY = 0;
constexpr int ORDER_STATE_STARTED = 0;
constexpr int ORDER_SYMBOL = 0;
constexpr int ORDER_TIME_DAY = 0;
constexpr int ORDER_TIME_DONE = 0;
constexpr int ORDER_TIME_DONE_MSC = 0;
constexpr int ORDER_TIME_EXPIRATION = 0;
constexpr int ORDER_TIME_GTC = 0;
constexpr int ORDER_TIME_SETUP = 0;
constexpr int ORDER_TIME_SETUP_MSC = 0;
constexpr int ORDER_TIME_SPECIFIED = 0;
constexpr int ORDER_TIME_SPECIFIED_DAY = 0;
constexpr int ORDER_TP = 0;
constexpr int ORDER_TYPE = 0;
constexpr int ORDER_TYPE_BUY = 0;
constexpr int ORDER_TYPE_BUY_LIMIT = 0;
constexpr int ORDER_TYPE_BUY_STOP = 0;
constexpr int ORDER_TYPE_BUY_STOP_LIMIT = 0;
constexpr int ORDER_TYPE_FILLING = 0;
constexpr int ORDER_TYPE_SELL = 0;
constexpr int ORDER_TYPE_SELL_LIMIT = 0;
constexpr int ORDER_TYPE_SELL_STOP = 0;
constexpr int ORDER_TYPE_SELL_STOP_LIMIT = 0;
constexpr int ORDER_TYPE_TIME = 0;
constexpr int ORDER_VOLUME_CURRENT = 0;
constexpr int ORDER_VOLUME_INITIAL = 0;
constexpr int PERIOD_CURRENT = 0;
constexpr int PERIOD_D1 = 0;
constexpr int PERIOD_H1 = 0;
constexpr int PERIOD_H12 = 0;
constexpr int PERIOD_H2 = 0;
constexpr int PERIOD_H3 = 0;
constexpr int PERIOD_H4 = 0;
constexpr int PERIOD_H6 = 0;
constexpr int PERIOD_H8 = 0;
constexpr int PERIOD_M1 = 0;
constexpr int PERIOD_M10 = 0;
constexpr int PERIOD_M12 = 0;
constexpr int PERIOD_M15 = 0;
constexpr int PERIOD_M2 = 0;
constexpr int PERIOD_M20 = 0;
constexpr int PERIOD_M3 = 0;
constexpr int PERIOD_M30 = 0;
constexpr int PERIOD_M4 = 0;
constexpr int PERIOD_M5 = 0;
constexpr int PERIOD_M6 = 0;
constexpr int PERIOD_MN1 = 0;
constexpr int PERIOD_W1 = 0;
constexpr int POINTER_AUTOMATIC = 0;
constexpr int POINTER_DYNAMIC = 0;
constexpr int POINTER_INVALID = 0;
constexpr int WHOLE_ARRAY = 0;
constexpr int clrAliceBlue = 0;
constexpr int clrAntiqueWhite = 0;
constexpr int clrAqua = 0;
constexpr int clrAquamarine = 0;
constexpr int clrBeige = 0;
constexpr int clrBisque = 0;
constexpr int clrBlack = 0;
constexpr int clrBlanchedAlmond = 0;
constexpr int clrBlue = 0;
constexpr int clrBlueViolet = 0;
constexpr int clrBrown = 0;
constexpr int clrBurlyWood = 0;
constexpr int clrCadetBlue = 0;
constexpr int clrChartreuse = 0;
constexpr int clrChocolate = 0;
constexpr int clrCoral = 0;
constexpr int clrCornflowerBlue = 0;
constexpr int clrCornsilk = 0;
constexpr int clrCrimson = 0;
constexpr int clrDarkBlue = 0;
constexpr int clrDarkGoldenrod = 0;
constexpr int clrDarkGray = 0;
constexpr int clrDarkGreen = 0;
constexpr int clrDarkKhaki = 0;
constexpr int clrDarkOliveGreen = 0;
constexpr int clrDarkOrange = 0;
constexpr int clrDarkOrchid = 0;
constexpr int clrDarkSalmon = 0;
constexpr int clrDarkSeaGreen = 0;
constexpr int clrDarkSlateBlue = 0;
constexpr int clrDarkSlateGray = 0;
constexpr int clrDarkTurquoise = 0;
constexpr int clrDarkViolet = 0;
constexpr int clrDeepPink = 0;
constexpr int clrDeepSkyBlue = 0;
constexpr int clrDimGray = 0;
constexpr int clrDodgerBlue = 0;
constexpr int clrFireBrick = 0;
constexpr int clrForestGreen = 0;
constexpr int clrGainsboro = 0;
constexpr int clrGold = 0;
constexpr int clrGoldenrod = 0;
constexpr int clrGray = 0;
constexpr int clrGreen = 0;
constexpr int clrGreenYellow = 0;
constexpr int clrHoneydew = 0;
constexpr int clrHotPink = 0;
constexpr int clrIndianRed = 0;
constexpr int clrIndigo = 0;
constexpr int clrIvory = 0;
constexpr int clrKhaki = 0;
constexpr int clrLavender = 0;
constexpr int clrLavenderBlush = 0;
constexpr int clrLawnGreen = 0;
constexpr int clrLemonChiffon = 0;
constexpr int clrLightBlue = 0;
constexpr int clrLightCoral = 0;
constexpr int clrLightCyan = 0;
constexpr int clrLightGoldenrod = 0;
constexpr int clrLightGray = 0;
constexpr int clrLightGreen = 0;
constexpr int clrLightPink = 0;
constexpr int clrLightSalmon = 0;
constexpr int clrLightSeaGreen = 0;
constexpr int clrLightSkyBlue = 0;
constexpr int clrLightSlateGray = 0;
constexpr int clrLightSteelBlue = 0;
constexpr int clrLightYellow = 0;
constexpr int clrLime = 0;
constexpr int clrLimeGreen = 0;
constexpr int clrLinen = 0;
constexpr int clrMagenta = 0;
constexpr int clrMaroon = 0;
constexpr int clrMediumAquamarine = 0;
constexpr int clrMediumBlue = 0;
constexpr int clrMediumOrchid = 0;
constexpr int clrMediumPurple = 0;
constexpr int clrMediumSeaGreen = 0;
constexpr int clrMediumSlateBlue = 0;
constexpr int clrMediumSpringGreen = 0;
constexpr int clrMediumTurquoise = 0;
constexpr int clrMediumVioletRed = 0;
constexpr int clrMidnightBlue = 0;
constexpr int clrMintCream = 0;
constexpr int clrMistyRose = 0;
constexpr int clrMoccasin = 0;
constexpr int clrNavajoWhite = 0;
constexpr int clrNavy = 0;
constexpr int clrNONE = 0;
constexpr int clrOldLace = 0;
constexpr int clrOlive = 0;
constexpr int clrOliveDrab = 0;
constexpr int clrOrange = 0;
constexpr int clrOrangeRed = 0;
constexpr int clrOrchid = 0;
constexpr int clrPaleGoldenrod = 0;
constexpr int clrPaleGreen = 0;
constexpr int clrPaleTurquoise = 0;
constexpr int clrPaleVioletRed = 0;
constexpr int clrPapayaWhip = 0;
constexpr int clrPeachPuff = 0;
constexpr int clrPeru = 0;
constexpr int clrPink = 0;
constexpr int clrPlum = 0;
constexpr int clrPowderBlue = 0;
constexpr int clrPurple = 0;
constexpr int clrRed = 0;
constexpr int clrRosyBrown = 0;
constexpr int clrRoyalBlue = 0;
constexpr int clrSaddleBrown = 0;
constexpr int clrSalmon = 0;
constexpr int clrSandyBrown = 0;
constexpr int clrSeaGreen = 0;
constexpr int clrSeashell = 0;
constexpr int clrSienna = 0;
constexpr int clrSilver = 0;
constexpr int clrSkyBlue = 0;
constexpr int clrSlateBlue = 0;
constexpr int clrSlateGray = 0;
constexpr int clrSnow = 0;
constexpr int clrSpringGreen = 0;
constexpr int clrSteelBlue = 0;
constexpr int clrTan = 0;
constexpr int clrTeal = 0;
constexpr int clrThistle = 0;
constexpr int clrTomato = 0;
constexpr int clrTurquoise = 0;
constexpr int clrViolet = 0;
constexpr int clrWheat = 0;
constexpr int clrWhite = 0;
constexpr int clrWhiteSmoke = 0;
constexpr int clrYellow = 0;
constexpr int clrYellowGreen = 0;
constexpr int CP_ACP = 0;
constexpr double DBL_MAX = 0;
constexpr unsigned UINT_MAX = 0;
constexpr int INT_VALUE = 4;    
constexpr int SHORT_VALUE = 2;    
constexpr int CHAR_VALUE = 1;    
constexpr int INVALID_HANDLE = 0;    


void printf(string format_string, ...);
bool FileIsExist( const string  file_name, int common_flag=0);
bool  FileIsEnding(
   int  file_handle      // handle файла
   );
#define ENUM_FILE_PROPERTY_INTEGER int
long  FileGetInteger(
   int                         file_handle,   // хэндл файла
   ENUM_FILE_PROPERTY_INTEGER  property_id    // идентификатор свойства
   );
long  FileGetInteger(
   const string                file_name,            // имя файла
   ENUM_FILE_PROPERTY_INTEGER  property_id,          // идентификатор свойства
   bool                        common_folder=false   // файл просматривается в локальной папке (false)
   );   
bool  FileIsLineEnding(
   int  file_handle      // handle файла
   );
int  FileOpen(
   string  file_name,           // имя файла
   int     open_flags,          // комбинация флагов
   short   delimiter='\t',      // разделитель
   uint    codepage=CP_ACP      // кодовая страница
   );
template <typename T>
uint  FileReadArray(
   int    file_handle,               // handle файла
   T array[],                        // массив для записи
   int    start=0,                   // стартовая позиция для записи в массив
   int    count=WHOLE_ARRAY          // сколько читать
   );
bool  FileReadBool(
   int  file_handle      // handle файла
   );
datetime  FileReadDatetime(
   int  file_handle      // handle файла
   );
double  FileReadDouble(
   int  file_handle      // handle файла
   );
float  FileReadFloat(
   int  file_handle      // handle файла
   );
int  FileReadInteger(
   int  file_handle,        // handle файла
   int  size=INT_VALUE      // размер целого типа в байтах
   );
long  FileReadLong(
   int  file_handle      // handle файла
   );
double  FileReadNumber(
   int  file_handle      // handle файла
   );
string  FileReadString(
   int  file_handle,     // handle файла
   int  length=-1        // длина строки
   );
template <typename T>
uint  FileReadStruct(
   int          file_handle,        // handle файла
   const T&  struct_object,      // структура, куда происходит считывание
   int          size=-1             // размер структуры в байтах
   );
bool  FileSeek(
   int                  file_handle,     // handle файла
   long                 offset,          // в байтах
   ENUM_FILE_POSITION   origin           // позиция для отсчета
   );
ulong  FileSize(
   int  file_handle      // handle файла
   );
ulong  FileTell(
   int  file_handle      // handle файла
   );
template <typename... T>
void  Alert(T...);
template <typename T>
int  ArraySize(const T  array[]);
string  CharArrayToString(
   uchar   array[],             // массив
   int     start=0,             // начальная позиция в массиве
   int     count=-1,            // количество символов
   uint    codepage=CP_ACP      // кодовая страница
   );
template <typename... T>
void  Comment(T...);
string  DoubleToString(
   double  value,      // число
   int     digits=8    // кол-во знаков после запятой
   );
string  EnumToString( int value);
double  exp( double  value);
bool  EventChartCustom(
   long    chart_id,            // идентификатор графика-получателя события
   ushort  custom_event_id,     // идентификатор события
   long    lparam,              // параметр типа long
   double  dparam,              // параметр типа double
   string  sparam               // строковый параметр события
   );
void  EventKillTimer();
bool  EventSetMillisecondTimer( int  milliseconds);
bool  EventSetTimer( int  seconds);
double  fabs( double  value);
double  MathAbs( double  value);
void  FileClose( int  file_handle);
uint  FileWrite(
   int  file_handle,     // handle файла
   ...                   // список записываемых параметров
   );
template <typename T>
uint  FileWriteArray(
   int          file_handle,         // handle файла
   const T array[],             // массив
   int          start=0,             // начальный индекс в массиве
   int          count=WHOLE_ARRAY    // количество элементов
   );
uint  FileWriteDouble(
   int     file_handle,     // handle файла
   double  value            // значения для записи
   );
uint  FileWriteFloat(
   int    file_handle,     // handle файла
   float  value            // записываемое значение
   );
uint  FileWriteInteger(
   int  file_handle,        // handle файла
   int  value,              // записываемое значение
   int  size=INT_VALUE      // размер в байтах
   );
uint  FileWriteLong(
   int   file_handle,     // handle файла
   long  value            // записываемое значение
   );
uint  FileWriteString(
   int           file_handle,    // handle файла
   const string  text_string,    // записываемая строка
   int           length=-1       // количество символов
   );
template <typename T>
uint  FileWriteStruct(
   int          file_handle,       // handle файла
   const T&  struct_object,     // ссылка на объект
   int          size=-1            // размер для записи в байтах
   );
bool  GlobalVariableCheck(
   string  name      // имя
   );
bool  GlobalVariableDel(
   string  name      // имя
   );
double  GlobalVariableGet(
   string  name      // имя
   );
bool  GlobalVariableGet(
   string  name,              // имя
   double& double_var         // сюда примем значение глобальной переменной
   );
string  GlobalVariableName(
   int  index      // номер в списке глобальных переменных
   );
int  GlobalVariablesDeleteAll(
   string     prefix_name=NULL,     // все глобальные переменные, чьи имена начинаются с префикса
   datetime   limit_data=0          // все глобальные переменные, которые изменялись ранее ранее указанной даты
   );
datetime  GlobalVariableSet(
   string  name,      // имя
   double  value      // устанавлимое значение
   );
bool  GlobalVariableSetOnCondition(
   string  name,            // имя
   double  value,           // значение при выполнении условия
   double  check_value      // проверяемое условие
   );
string  IntegerToString(
   long    number,              // число
   int     str_len=0,           // длина строки на выходе
   ushort  fill_symbol=' '      // заполнитель
   );
string Symbol();

//--------------------------------------------------------------------
#endif

#endif //VIM_MQH
